<template>
  <div class="q-pa-md">
    <h4 class="text-h4 q-mt-sm q-mb-lg text-weight-medium">Admin Dashboard</h4>

    <div class="row col-xs-6 col-sm-6 col-md-4 q-gutter-xl">
      <q-card class="my-card lilac">
        <q-card-section>
          <h5 class="text-h5">{{currentUserProducts.length}} orders</h5>
        </q-card-section>
      </q-card>
      <q-card class="my-card green">
        <q-card-section>
          <h5 class="text-h5">{{products.length}} products</h5>
        </q-card-section>
      </q-card>
    </div>

    <h5 class="text-h5">Customize</h5>
    <div class="column customize">
      <div class="row justify-around items-center details q-my-md">
        <p class="text-weight-medium">BRAND NAME</p>
        <p v-if="!isEdit.brandName" class="text-body1">{{ newDetails.brandName }}</p>
        <q-btn v-if="!isEdit.brandName" @click="editBrandName" color="primary" label="Edit" />
        <q-input v-if="isEdit.brandName" dense outlined v-model="newDetails.brandName" />
        <q-btn v-if="isEdit.brandName" @click="saveBrandName" color="primary" label="Save" />
        <q-btn
          v-if="isEdit.brandName"
          @click="isEdit.brandName = false"
          color="primary"
          label="Cancel"
        />
      </div>
      <div class="row justify-around items-center details q-my-md">
        <p class="text-weight-medium">ITEMS ON THE FIRST PAGE</p>
        <div class="row items-center">
          <q-toggle
            :false-value="3"
            :true-value="6"
            left-label
            v-model="newDetails.noItems"
            @input="updateNoItems()"
            color="green"
            label="3"
          />
          <p>6</p>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { LocalStorage } from "quasar";

export default {
  name: "admin-dashboard",
  data() {
    return {
      newDetails: {
        brandName: "",
        noItems: 0,
      },
      isEdit: {
        brandName: false,
      },
    };
  },
  beforeMount() {
    if (!LocalStorage.getItem("loggedIn")) {
      this.$router.push("/auth");
    } else if (!LocalStorage.getItem("user").isAdmin) this.$router.push("/");
  },
  async mounted() {
    setTimeout(() => {
      this.newDetails.brandName = this.brandName;
      this.newDetails.noItems = this.noItems;
    }, 500);
  },
  computed: {
    adminPreferences() {
      return this.$store.getters["adminData/getAdminPreferences"];
    },
    brandName() {
      return this.adminPreferences.find(
        (preference) => preference.name === "brandName"
      ).value;
    },
    noItems() {
      return parseFloat(
        this.adminPreferences.find(
          (preference) => preference.name === "noItems"
        ).value
      );
    },
    products() {
      return this.$store.getters["adminData/getProducts"];
    },
    currentUserProducts() {
      return this.$store.getters["adminData/getAllUsersProducts"].filter(
        (item) =>
          item.status != "CANCELED" &&
          item.status != "RETURNED" &&
          item.status != "DENIED"
      );
    },
  },
  methods: {
    updateNoItems() {
      this.$axios
        .put("/api/preferences", {
          name: "noItems",
          value: this.newDetails.noItems,
        })
        .then((response) => {
          this.$q.notify({
            message: "Numarul de elemente in carusel a fost actualizat",
            color: "positive",
          });
          this.$store.dispatch("adminData/loadAdminPreferences");
        })
        .catch((error) => {
          this.$q.notify({
            color: "negative",

            message: error.response.data.message,
            icon: "report_problem",
          });
        });
    },
    editBrandName() {
      this.isEdit.brandName = true;
    },
    saveBrandName() {
      this.$axios
        .put("/api/preferences", {
          name: "brandName",
          value: this.newDetails.brandName,
        })
        .then((response) => {
          this.$q.notify({
            message: "Numele brandului a fost modificat cu succes",
            color: "positive",
          });
          this.isEdit.brandName = false;
          this.$store.dispatch("adminData/loadAdminPreferences");
        })
        .catch((error) => {
          this.$q.notify({
            color: "negative",

            message: error.response.data.message,
            icon: "report_problem",
          });
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.my-card {
  width: 100%;
  max-width: 250px;
  font-size: 10px;
  padding-top: 10%;
  border: 1px solid #b89eb2;
  h5 {
    margin: 0;
  }
}
.customize {
  background-color: #f2f2f2;
  .details {
    p {
      margin: 0;
    }
  }
}
</style>
